/* Rebuild by UFPS.Team */

#include <amxmodx>
#include <amxmisc>


#define PLUGIN 		"High Ping Kicker (STEAM)"
#define VERSION		"0.16.2"
#define AUTHOR		"OLO/Shadow"

#define HPK_PARAMS	4

#define ID_PING		0
#define ID_CHECK	1
#define ID_TESTS	2
#define ID_DELAY	3


new g_Ping[33]
new g_Samples[33]

new pcv_hpk_ping
new pcv_hpk_check
new pcv_hpk_tests
new pcv_hpk_delay

new const hpk_min[HPK_PARAMS] = { 0, 5, 3, 0 }
new const hpk_max[HPK_PARAMS] = { 1000, 20, 20, 600 }

public plugin_init ( )
{
	register_plugin ( PLUGIN, VERSION, AUTHOR )
	register_dictionary ( "hpk.txt" )

	register_concmd ( "amx_hpk", "cmdHpk", ADMIN_KICK, "- configures high_ping_kicker plugin" )

	pcv_hpk_ping	= register_cvar ( "amx_hpk_ping",  "200" )
	pcv_hpk_check	= register_cvar ( "amx_hpk_check", "12"  )
	pcv_hpk_tests	= register_cvar ( "amx_hpk_tests", "5"   )
	pcv_hpk_delay	= register_cvar ( "amx_hpk_delay", "60"  )
}

public client_disconnect ( id ) if ( task_exists ( id ) ) remove_task ( id )

public client_putinserver ( id )
{
	if ( task_exists ( id ) ) remove_task ( id )

	g_Ping[id] = 0
	g_Samples[id] = 0

	if ( !is_user_bot ( id ) )
	{
		set_task( 10.0 , "showWarn" , id )

 		new hpk_delay = hpk_clamp ( ID_DELAY, pcv_hpk_delay )

		if ( hpk_delay )
			set_task ( float ( hpk_delay ), "taskSetting", id )

		else
			taskSetting ( id )
	}
}

public showWarn ( id )
{
	client_print ( id, print_chat, "%L", id, "HPK_WARNING", get_pcvar_num ( pcv_hpk_ping ) )
}

public taskSetting ( id )
{
	if ( !( get_user_flags ( id ) & ADMIN_IMMUNITY ) )
	{
		set_task ( float ( hpk_clamp ( ID_TESTS, pcv_hpk_tests ) ), "checkPing", id, _, _, "b", hpk_clamp ( ID_CHECK, pcv_hpk_check ) )
	}
}

stock kickPlayer ( id )
{
	static name[32], authid[32]

	get_user_name ( id, name, charsmax ( name ) )
	get_user_authid ( id, authid, charsmax ( authid ) )

	client_print ( 0, print_chat, "%L", LANG_PLAYER, "HPK_KICKMSG", name )
	server_cmd ( "kick #%d ^"%L^"", id, "HPK_REASON", get_user_userid ( id ) )
	log_amx ( "HPK: ^"%s<%d><%s>^" was kicked due high ping (average ping: %d)", name, get_user_userid ( id ), authid, ( g_Ping[id] / g_Samples[id] ) )
}

stock hpk_clamp ( hpk_id, hpk_cvar )
	return  clamp ( get_pcvar_num ( hpk_cvar ), hpk_min[hpk_id], hpk_max[hpk_id] )

public checkPing ( id )
{
	static p, l
	get_user_ping ( id, p, l )

	g_Ping[id] += p
	g_Samples[id]++

	if ( g_Samples[id] > hpk_clamp ( ID_CHECK, pcv_hpk_check ) )
	{
		if ( ( g_Ping[id] / g_Samples[id] ) > hpk_clamp ( ID_PING, pcv_hpk_ping ) )
		{
			kickPlayer ( id )
		}
	}
}

public cmdHpk ( id, level, cid )
{
	if ( !cmd_access ( id, level, cid, 1 ) )
		return PLUGIN_HANDLED

	static arg[5], i

	new hpk_cvar[HPK_PARAMS], hpk_value[HPK_PARAMS]
	hpk_cvar[0] = pcv_hpk_ping
	hpk_cvar[1] = pcv_hpk_check
	hpk_cvar[2] = pcv_hpk_tests
	hpk_cvar[3] = pcv_hpk_delay

	new args = read_argc ( ) - 1

	for ( i = 0; i < HPK_PARAMS; i++ )
	{
		if ( i < args )
		{
			read_argv ( i + 1, arg, charsmax ( arg ) )
			hpk_value[i] = clamp ( str_to_num ( arg ), hpk_min[i], hpk_max[i]  )
		}
	
		else
		{
			hpk_value[i] = hpk_clamp ( i,  hpk_cvar[i] )
		}

		set_pcvar_num ( hpk_cvar[i], hpk_value[i] )
	}

	console_print ( id, "%L", id, "HPK_INFO1" )
	console_print ( id, "%L", id, "HPK_INFO2" )
	console_print ( id, "%L", id, "HPK_INFO3", hpk_value[ID_PING], hpk_value[ID_CHECK], hpk_value[ID_TESTS], hpk_value[ID_DELAY] )

	return PLUGIN_HANDLED
}
